unit pathdemofrm;

interface

uses
  {$IFNDEF FPC}Windows, {$ELSE}LResources,{$ENDIF} SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, dx_scene, dx_vgcore, dx_objects, dx_vglayer, dx_utils;

type
  TfrmPathDemo = class(TForm)
    dxScene1: TdxScene;
    Root1: TdxVisualObject;
    Toolbar: TdxGUIObjectLayer;
    Root2: TvxLayout;
    cameraz: TdxDummy;
    camerax: TdxDummy;
    Camera1: TdxCamera;
    Light1: TdxLight;
    Path3D: TdxPath3D;
    Rectangle1: TvxRectangle;
    PathList: TvxHudListBox;
    HudLabel1: TvxHudLabel;
    ListBoxItem1: TvxListBoxItem;
    Path1: TvxPath;
    Path2: TvxPath;
    ListBoxItem2: TvxListBoxItem;
    ListBoxItem3: TvxListBoxItem;
    ListBoxItem4: TvxListBoxItem;
    ListBoxItem5: TvxListBoxItem;
    ListBoxItem6: TvxListBoxItem;
    ListBoxItem7: TvxListBoxItem;
    ListBoxItem8: TvxListBoxItem;
    ListBoxItem9: TvxListBoxItem;
    ListBoxItem10: TvxListBoxItem;
    ListBoxItem11: TvxListBoxItem;
    ListBoxItem12: TvxListBoxItem;
    ListBoxItem13: TvxListBoxItem;
    ListBoxItem14: TvxListBoxItem;
    ListBoxItem15: TvxListBoxItem;
    ListBoxItem16: TvxListBoxItem;
    ListBoxItem17: TvxListBoxItem;
    ListBoxItem18: TvxListBoxItem;
    CompoundTrackBar1: TvxCompoundTrackBar;
    ColorPicker1: TvxColorPicker;
    ColorQuad1: TvxColorQuad;
    ColorBox1: TvxColorBox;
    CompoundTrackBar2: TvxCompoundTrackBar;
    procedure PathListChange(Sender: TObject);
    procedure Root1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single; rayPos, rayDir: TdxVector);
    procedure Root1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Single; rayPos, rayDir: TdxVector);
    procedure CompoundTrackBar1Change(Sender: TObject);
    procedure ColorQuad1Change(Sender: TObject);
    procedure Root1MouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TdxPoint; var Handled: Boolean);
    procedure CompoundTrackBar2Change(Sender: TObject);
  private
    { Private declarations }
    Down: TdxPoint;
  public
    { Public declarations }
  end;

var
  frmPathDemo: TfrmPathDemo;

implementation

{$R *.dfm}

procedure TfrmPathDemo.PathListChange(Sender: TObject);
var
  P: TvxPath;
begin
  if PathList.Selected = nil then Exit;
  P := TvxPath(PathList.Selected.FindBinding('path'));
  if P <> nil then
  begin
    Path3D.Path.Assign(P.Data);
  end;
end;

procedure TfrmPathDemo.Root1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Single; rayPos, rayDir: TdxVector);
begin
  Down := dxPoint(X, Y, 0);
end;

procedure TfrmPathDemo.Root1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Single; rayPos, rayDir: TdxVector);
begin
  if ssLeft in Shift then
  begin
    cameraz.RotateAngle.Z := cameraz.RotateAngle.Z + (X - Down.X);
    camerax.RotateAngle.X := camerax.RotateAngle.X + (Y - Down.Y);
    Down := dxPoint(X, Y, 0);
  end;
end;

procedure TfrmPathDemo.CompoundTrackBar1Change(Sender: TObject);
begin
  Path3D.Depth := CompoundTrackBar1.Value;
end;

procedure TfrmPathDemo.ColorQuad1Change(Sender: TObject);
begin
  Path3D.Material.Diffuse := dxColorToStr(ColorBox1.Color);
end;

procedure TfrmPathDemo.Root1MouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TdxPoint; var Handled: Boolean);
begin
  Camera1.Position.Vector := dxVectorAdd(Camera1.Position.Vector, dxVectorScale(dxVector(0, 1, 0),
    (WheelDelta{$ifndef FPC}/30{$endif}) * 0.3));
end;

procedure TfrmPathDemo.CompoundTrackBar2Change(Sender: TObject);
begin
  Path3D.Flatness := CompoundTrackBar2.Value;
end;

end.
